% EC4910: Channel Estimation
% Roberto Cristi, 11/04/2010

% run model "project5.mdl" first
FDmax=100;                          % upper bound on Doppler sprread(in Hz)
N=2^floor(log2(Fs/(10*FDmax)));     % block length as power of 2
Nb=2^floor(log2(length(y)/N));      % number of blocks as power of 2

x=x(1:N*Nb);
y=y(1:N*Nb);                        % keep only an integer number of blocks

x=x-mean(x); y=y-mean(y);
Y=reshape(y,N,length(y)/N);         % data blocks
X=reshape(x,N,length(x)/N);


% compute the crosscorrelation of each block using the FFT (much faster!)

Ryx=fft(Y, 2*N).*conj(fft(X, 2*N)); % cross correlate each data block
h=ifft(Ryx);                        % each column is impulse response
h=h.';                       % take the transpose because we need it later

% Example: plot an arbitrary row
choose_one=100;
plot((-N:N-1)/Fs, fftshift(abs(h(choose_one,:)))), xlabel('sec')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%    YOUR CODE HERE
%
%
% plot(t, St), title('channel time spread'), xlabel('sec')
% plot(F, SF), title('channel frequency spread'), xlabel('Hz')

